% Required for the Matlab code example for Algorithm 1 presented in "Sparse 
% Fast DCT for Vectors with One-block Support" by Sina Bittens and Gerlind
% Plonka.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [ supp_struct, mu1, m1 ] = find_supp_3(j,mu,m,lambda)
%FIND_SUPP_3 Finds the support structure of y^(j+1) if y^(j) has a 
% two-block support.
% supp_struct==1 if y has a one-block support, supp_struct==2 if y has a
% two-block support and supp_struct==3 if it has a two-block support with 
% possibly different block lengths (only possible for j=J-1).
% If y^(j) has a two-block support, y^(j+1) has a two-block support as 
% well.

% The first support index of the first block only depends on the previously
% computed values lambda, mu and m, and j. 
if lambda==mu
    mu1=mu;
elseif lambda==2^j+mu
    mu1=2^j-m-mu;
end
% Block length in y^(j+1).
m1=m;
% Support structure of y^(j+1).
supp_struct=2;

end
